
#pragma once
#include "B4RDefines.h"
#include "GSM_MQTT.h"

    //~Event: AutoConnect()
    //~Event: OnConnect()
    //~Event: OnMessage(Topic As String, Message() As Byte)
    //~Version: 1.0 
    //~Author - 
    //~Libray from Arduino

namespace B4R {
    typedef void (*SubVoid1Void)(void);
    typedef void (*SubVoid2Void)(void);
    typedef void (*SubVoid1StringBArray)(B4RString* str, Array* barray);
    //~shortname:GSM_MQTT
    class B4RGSM_MQTT
    {
        private:
            uint8_t backend[sizeof(GSM_MQTT)];
            GSM_MQTT* rcs;
            PollerNode pnode;
            SubVoid1Void AutoConnectSub;
            SubVoid2Void OnConnectSub;
            SubVoid1StringBArray OnMessageSub;
            static void looper(void* b);
        public: 
            void Initialize(ulong KeepAlive, int LogBauds,byte LogRX,byte LogTX,B4RString* MqttHost,B4RString* MqttPort, SubVoid1Void AutoConnectSub, SubVoid2Void OnConnectSub, SubVoid1StringBArray OnMessageSub);
            void connect(B4RString* ClientIdentifier, byte UserNameFlag, byte PassuintFlag, B4RString* UserName, B4RString* Passuint, byte CleanSession, byte WillFlag, byte WillQoS, byte WillRetain, B4RString* WillTopic, B4RString* WillMessage);
            void publish(byte DUP, byte Qos, byte RETAIN, uint MessageID, B4RString* Topic, B4RString* Message);
            void subscribe(byte DUP, uint MessageID, B4RString* SubTopic, byte SubQoS);
            void unsubscribe(byte DUP, uint MessageID, B4RString* SubTopic);
            void disconnect();
            bool available();
            void Log(B4RString* Mess);
            void publishACK(uint MessageID);
            void publishREC(uint MessageID);
            void publishREL(byte DUP, uint MessageID);
            void publishCOMP(uint MessageID);
            void printMessageType(byte Message);
            void printConnectAck(byte Ack);
            byte sendATreply(B4RString* command, B4RString* replystr, ulong waitms);
    };
}


